/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   manage_keys.c                                      :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: erey-bet <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2023/04/27 14:14:51 by erey-bet          #+#    #+#             */
/*   Updated: 2023/06/13 13:28:58 by erey-bet         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "game.h"

void	rotate(t_ply *ply, bool right)
{
	double	old_dir_x;
	double	old_dir_y;
	double	old_plane_x;
	double	old_plane_y;
	double	speed;

	old_dir_x = ply->dir_x;
	old_dir_y = ply->dir_y;
	old_plane_x = ply->pla_x;
	old_plane_y = ply->pla_y;
	speed = ROTATIONSPEED * (M_1_PI / 180.0);
	if (!right)
		speed = -speed;
	ply->dir_x = old_dir_x * cos(speed) - old_dir_y * sin(speed);
	ply->dir_y = old_dir_x * sin(speed) + old_dir_y * cos(speed);
	ply->pla_x = old_plane_x * cos(speed) - old_plane_y * sin(speed);
	ply->pla_y = old_plane_x * sin(speed) + old_plane_y * cos(speed);
}

void	movement(t_ply *ply, double x, double y)
{
	ply->pos_x += x;
	ply->pos_y += y;
}

int	manage_movement(t_game *game)
{
	t_ply	*ply;
	int	is_moving;

	ply = &game->ply;
	is_moving = 1;
	if (mlx_is_key_down(game->mlx, MLX_KEY_W))
		movement(ply, (ply->dir_x * MOVESPEED), (ply->dir_y * MOVESPEED));
	else if (mlx_is_key_down(game->mlx, MLX_KEY_S))
		movement(ply, -(ply->dir_x * MOVESPEED), -(ply->dir_y * MOVESPEED));
	else if (mlx_is_key_down(game->mlx, MLX_KEY_D))
		movement(ply, (ply->pla_x * MOVESPEED), (ply->pla_y * MOVESPEED));
	else if (mlx_is_key_down(game->mlx, MLX_KEY_A))
		movement(ply, -(ply->pla_x * MOVESPEED), -(ply->pla_y * MOVESPEED));
	else if (mlx_is_key_down(game->mlx, MLX_KEY_RIGHT))
		rotate(ply, true);
	else if (mlx_is_key_down(game->mlx, MLX_KEY_LEFT))
		rotate(ply, false);
	else
		is_moving = 0;
	return (is_moving);
}

int	manage_keys(t_game *game)
{

	if (mlx_is_key_down(game->mlx, MLX_KEY_ESCAPE))
		mlx_close_window(game->mlx);
	if (manage_movement(game))
		return (1);
	return (0);
}
